<template>
  <q-layout view="lHh Lpr lff">
    <q-header>
      <q-toolbar>
        <q-btn
          flat
          round
          dense
          color="grey-1"
          icon="menu"
          class="q-mr-sm"
          @click="leftDrawerOpen = !leftDrawerOpen"
        />
        <!-- <q-toolbar-title>Hoverlook</q-toolbar-title> -->
        <q-toolbar-title class="grey-1-header" style="flex:none;">
          {{
          currentMonth
          }}
        </q-toolbar-title>
        <q-space />
        <q-btn round flat color="grey-1" icon="keyboard_arrow_left" @click="handleCalNav('prev')" />
        <q-btn class="hover-avatar" round flat @click="handleCalNav('today')">
          <q-avatar square size="24px">
            <img
              src="
                    /statics/images/go-to-current-month.svg
                  "
            />
          </q-avatar>
        </q-btn>
        <q-btn round flat color="grey-1" icon="keyboard_arrow_right" @click="handleCalNav('next')" />
      </q-toolbar>
    </q-header>

    <q-drawer v-model="leftDrawerOpen" :width="250" :breakpoint="600">
      <q-img class="absolute-top" src="statics/images/zigzag.svg" style="height: 178px">
        <div class="absolute-bottom bg-transparent">
          <q-avatar size="56px" class="q-mb-sm">
            <q-img :src="user.avatar || 'statics/images/mike-j-hover.svg'">
              <template v-slot:loading>
                <div class="text-yellow">
                  <q-spinner-ios />
                </div>
              </template>
            </q-img>

            <!-- <img :src="userAvatar || 'statics/images/mike-j-hover.svg'" /> -->
          </q-avatar>
          <div class="text-weight-bold text-grey-1">{{ user.name }}</div>
          <div class="text-grey-1">{{ user.address }}</div>
        </div>
      </q-img>
      <q-scroll-area
        style="height: calc(100% - 356px); margin-top: 178px; border-right: 0px solid #ddd"
      >
        <q-list padding>
          <!-- <q-item
              clickable
              v-ripple
              class="text-grey-1"
              @click="$q.dark.toggle()"
            >
              <q-item-section avatar>
                <q-icon name="wb_sunny" />
              </q-item-section>

              <q-item-section>Toggle Light/Dark Mode</q-item-section>
          </q-item>-->

          <q-item clickable v-ripple class="text-grey-1" @click="signOut" v-if="user.authenticated">
            <q-item-section style="min-width=0px" avatar>
              <img src="
                    /statics/images/sign-out.svg
                  " />
            </q-item-section>

            <q-item-section>Sign out</q-item-section>
          </q-item>
        </q-list>
      </q-scroll-area>
      <q-img src="statics/images/logo-drawer.svg" style="height: 178px"></q-img>
    </q-drawer>

    <q-page-container>
      <keep-alive>
        <router-view />
      </keep-alive>
    </q-page-container>
  </q-layout>
</template>

<script>
/* eslint-disable no-unused-vars */
import { mapActions, mapState } from "vuex";

import dayjs from "dayjs";
import { userSession } from "boot/blockstack";
import { date } from "quasar";
// const Box = require("3box");

// blockstack setup

export default {
  name: "Layout",
  components: {},
  data() {
    return {
      leftDrawerOpen: false,
      currentMonth: dayjs(new Date().toISOString().slice(0, 10)).format("MMMM"),
      box: null,
      space: null,
      userAvatar: null,
      userName: null,
      userAddress: null,
      profile: null
    };
  },
  mounted() {},
  created() {
    this.$root.$on("updateMonthDisplay", this.toolbarHeader);
  },
  beforeDestroy() {
    this.$root.$off("updateMonthDisplay", this.toolbarHeader);
  },
  computed: {
    ...mapState(["user"])
  },
  methods: {
    ...mapActions(["setUser", "web3LoadData", "setNotes"]),
    toolbarHeader(start) {
      if (start === undefined) {
        this.currentMonth = dayjs(new Date().toISOString().slice(0, 10)).format(
          "MMMM"
        );
      } else {
        this.currentMonth = dayjs(start).format("MMMM");
      }
    },
    handleCalNav(to) {
      this.$root.$emit("navigate", to);
    },

    async signOut() {
      this.setUser({ authenticated: false });
      this.setNotes({});
      userSession.signUserOut("/");
    }
  }
};
</script>
<style scoped></style>
